一键安装最新内核并开启 BBR 脚本

技术 458074 次围观 413 次吐槽

最近,Google 开源了其 TCP BBR 拥塞控制算法,并提交到了 Linux 内核,从 4.9 开始,Linux 内核已经用上了该算法。根据以往的传统,Google 总是先在自家的生产环境上线运用后,才会将代码开源,此次也不例外。
根据实地测试,在部署了最新版内核并开启了 TCP BBR 的机器上,网速甚至可以提升好几个数量级。
于是我根据目前三大发行版的最新内核,开发了一键安装最新内核并开启 TCP BBR 脚本。

本脚本适用环境

系统支持:CentOS 6+,Debian 7+,Ubuntu 12+
虚拟技术:OpenVZ 以外的,比如 KVM、Xen、VMware 等
内存要求:≥128M
日期  :2017 年 10 月 28 日

关于本脚本

1、本脚本已在 Vultr 上的 VPS 全部测试通过。
2、当脚本检测到 VPS 的虚拟方式为 OpenVZ 时,会提示错误,并自动退出安装。
3、脚本运行完重启发现开不了机的,打开 VPS 后台控制面板的 VNC, 开机卡在 grub 引导, 手动选择内核即可。
4、由于是使用最新版系统内核,最好请勿在生产环境安装,以免产生不可预测之后果。

使用方法

使用root用户登录,运行以下命令:

wget --no-check-certificate https://github.com/teddysun/across/raw/master/bbr.sh && chmod +x bbr.sh && ./bbr.sh

安装完成后,脚本会提示需要重启 VPS,输入 y 并回车后重启。
重启完成后,进入 VPS,验证一下是否成功安装最新内核并开启 TCP BBR,输入以下命令:

uname -r

查看内核版本,含有 4.13 就表示 OK 了

sysctl net.ipv4.tcp_available_congestion_control

返回值一般为:
net.ipv4.tcp_available_congestion_control = bbr cubic reno

sysctl net.ipv4.tcp_congestion_control

返回值一般为:
net.ipv4.tcp_congestion_control = bbr

sysctl net.core.default_qdisc

返回值一般为:
net.core.default_qdisc = fq

lsmod | grep bbr

返回值有 tcp_bbr 模块即说明 bbr 已启动。注意:并不是所有的 VPS 都会有此返回值,若没有也属正常。

内核升级方法

如果是 CentOS 系统,执行如下命令即可升级内核:

yum --enablerepo=elrepo-kernel -y install kernel-ml kernel-ml-devel

CentOS 6 的话,执行命令:

sed -i 's/^default=.*/default=0/g' /boot/grub/grub.conf

CentOS 7 的话,执行命令:

grub2-set-default 0

如果是 Debian/Ubuntu 系统,则需要手动下载最新版内核来安装升级。
这里下载最新版的内核 deb 安装包。
如果系统是 64 位,则下载 amd64 的 linux-image 中含有 generic 这个 deb 包;
如果系统是 32 位,则下载 i386 的 linux-image 中含有 generic 这个 deb 包;
安装的命令如下(以最新版的 64 位 4.12.4 举例而已,请替换为下载好的 deb 包):

dpkg -i linux-image-4.12.4-041204-generic_4.12.4-041204.201707271932_amd64.deb

安装完成后,再执行命令:

/usr/sbin/update-grub

最后,重启 VPS 即可。

特别说明

如果你使用的是 Google Cloud Platform (GCP)更换内核,有时会遇到重启后,整个磁盘变为只读的情况。只需执行以下命令即可恢复:

mount -o remount rw /

更新日志:

2017 年 10 月 28 日:
1、更新:自动判断内核版本。如果内核版本已经大于或等于 4.9 且没有开启 BBR,脚本会直接设置好 BBR;
2、新增:脚本执行时会在当前目录下创建日志(install_bbr.log),方便查看及排错。

2017 年 02 月 22 日:
1、更新:自动获取最新版 4.10 内核。

2017 年 01 月 20 日:
1、新增:自动获取并下载安装最新版内核的功能。

2017 年 01 月 13 日:
1、更新:内核到 4.9.3。

2017 年 01 月 09 日:
1、更新:内核到 4.9.1。

参考链接:

https://github.com/google/bbr/blob/master/Documentation/bbr-quick-start.md
http://elrepo.org/tiki/tiki-index.php
http://kernel.ubuntu.com/~kernel-ppa/mainline/

转载请注明:秋水逸冰 » 一键安装最新内核并开启 BBR 脚本

发表评论
取消评论
  • 昵称 (必填)
  • 邮箱 (必填)
  • 网址
表情

已有评论 (413)

  1. 你好,博主,感觉你的脚本非常好用,但是唯独缺少魔改bbr,能整合进去吗? 网上找了几个魔改bbr脚本感觉不太好用.
    yutr48912周前 (2017-11-09)回复
  2. 老大好;刚接触vps 比较陌生,幸好有您带路学会很多,现在可以ss上网 感到外面的世界很精彩。谢谢您!另:我linode vps 和我本地路由器应该如何设置才在我本地通过ipv6 联网?爬墙恒久 还是没搞懂 连不上 ipv6 请指教 谢谢
    彼岸更美2周前 (2017-11-09)回复
  3. 请问用什么软件输入命令
    1234562周前 (2017-11-08)回复
  4. 时间:2017-11-08 主题:Linode Debian8 内核无法升级 博主,您好,一键脚本目前Linode Debian 8不能生效,手动安装4.13内核能安装上,但是内核还是默认4.9.50, BBR加速好像不能生效。 [email protected]:~# uname -r 4.9.50-x86_64-linode86 [email protected]:~# sysctl net.ipv4.tcp_available_congestion_control net.ipv4.tcp_available_congestion_control = cubic reno bbr bic westwood htcp [email protected]:~# sysctl net.ipv4.tcp_congestion_control net.ipv4.tcp_congestion_control = cubic [email protected]:~# sysctl net.core.default_qdisc net.core.default_qdisc = fq [email protected]:~# lsmod | grep bbr [email protected]:~#
    Nicholas8202周前 (2017-11-08)回复
    • 内核原生支持 bbr 的情况下就不用升级内核了
      秋水逸冰2周前 (2017-11-11)回复
  5. 博主,我执行了一键脚本,返回值全部正常。那文章里面的“内核升级方法”的命令就不用再执行了吧?
    12343周前 (2017-11-07)回复
  6. Found linux image: /boot/vmlinuz-4.14.0-041400rc8-generic Found initrd image: /boot/initrd.img-4.14.0-041400rc8-generic Found linux image: /boot/vmlinuz-3.16.0-4-amd64 Found initrd image: /boot/initrd.img-3.16.0-4-amd64 Segmentation fault 卡住了debian8
    老马3周前 (2017-11-06)回复
  7. 脚本合并下呗,一次拷贝就好了,现在要拷贝3次 wget --no-check-certificate https://github.com/teddysun/across/raw/master/bbr.sh && chmod +x bbr.sh && ./bbr.sh
    jalena3周前 (2017-11-06)回复
    • 有道理。
      秋水逸冰3周前 (2017-11-06)回复
      • 老格式更加美观和分明啊!!建议依然采用老格式呢!
        DAII3周前 (2017-11-07)回复
  8. 用的BBR 然后装上了锐速 后来想换回BBR 用之前大大的那个命令 安装以后显示 already installed and latest version nothing to do reboot 以后 使用uname -r 命令仍然不能正确显示出4.13 这个怎么解决啊
    雷羽风3周前 (2017-11-05)回复
    • 内核一旦升级过了,就会开启 BBR 了,所以脚本才会显示已经安装,无需再次安装。
      秋水逸冰3周前 (2017-11-06)回复
  9. 手动下载的deb放哪里呀
    3周前 (2017-11-04)回复
  10. 我的内核是4.9,也显示安装了bbr了,但是lsmod的时候没有bbr显示。。。重启好多次了。。。
    feng3周前 (2017-11-02)回复
    • 这个没关系的。
      秋水逸冰3周前 (2017-11-03)回复
      • 那现在怎么查看bbr是否开启正常呢?只能看是否安装吗?
        feng3周前 (2017-11-04)回复
        • 再次运行脚本,默认会检查,一旦发现已开启 BBR,会提示并退出运行。
          秋水逸冰3周前 (2017-11-06)回复
  11. vultr centos 6.9 X64 脚本执行完成后重启网卡就没了。结果就是系统再也上不去了,折腾半天无果··还好我机智的做了个快照,恢复了一下之后是yum update之后再执行的一键安装脚本,重启后一次性成功了。各位安装之前建议先更新下系统。
    kole4周前 (2017-10-31)回复
  12. 重启后通过vultr的vnc登录显示下面错误信息,无法进入了,vps上还有很重要的信息啊!要哭了,楼主有遇到过吗? kernel offset: disabled ---[ end kernel panic -not syncing:
    拜托了4周前 (2017-10-31)回复
    • 这个我已经在文章里写了,最好不要用于生产环境。 这种情况应该先做个快照再升级内核。万一安装失败还能恢复。 关于这个错误信息,应该是内核启动失败。去 Google 一下看看有没有解决方案吧。抱歉,帮不了你。
      秋水逸冰4周前 (2017-10-31)回复
  13. vultr的centos6 64位,为啥提示脚本不支持啊???
    feng4周前 (2017-10-31)回复
  14. rpm -Uvh http://www.elrepo.org/elrepo-release-6-8.el6.elrepo.noarch.rpm 得先输入这个,再升级内核~不然找不到rpm源
    feng4周前 (2017-10-31)回复
  15. yum --enablerepo=elrepo-kernel -y install kernel-ml kernel-ml-devel elrepo-kernel这个源好像不在啊
    feng4周前 (2017-10-31)回复
    • 那就是因为VPS上并没有安装此源。如果VPS本身的内核已经大于等于4.9时,就自动设定 BBR,并不会安装最新内核。
      秋水逸冰4周前 (2017-10-31)回复